org.jgroups.protocols

## Class FD_ALL

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.FD_ALL

    public class FD_ALL
    extends Protocol

Failure detection based on simple heartbeat protocol. Every member periodically multicasts a heartbeat. Every member also maintains a table of all members (minus itself). When data or a heartbeat from P is received, we reset the timestamp for P to the current time. Periodically, we check for expired members, and suspect those. Reduced number of messages exchanged on suspect event: https://jira.jboss.org/browse/JGRP-1241

Author:
  Bela Ban

### Nested Class Summary

Nested Classes
`static class` `FD_ALL.HeartbeatHeader`

### Field Summary

Fields
`protected int` `num_heartbeats_received`
`protected int` `num_heartbeats_sent`
`protected int` `num_suspect_events`
`protected java.util.Set<Address>` `suspected_mbrs`

### Fields inherited from class org.jgroups.stack.Protocol

`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

### Constructor Summary

Constructors
Constructor and Description
`FD_ALL()`

### Method Summary

Methods
`java.lang.Object` `down(Event evt)` An event is to be sent down the stack.
`int` `getHeartbeatsReceived()`
`int` `getHeartbeatsSent()`
`long` `getInterval()`
`java.lang.String` `getLocalAddress()`
`java.lang.String` `getMembers()`
`java.lang.String` `getSuspectedMembers()`
`int` `getSuspectEventsSent()`
`long` `getTimeout()`
`void` `init()` Called after instance has been created (null constructor) and before protocol is started.
`boolean` `isRunning()`
`static boolean` `isShun()` Deprecated.
`java.lang.String` `printSuspectHistory()`
`java.lang.String` `printTimestamps()`
`void` `resetStats()`
`void` `setInterval(long interval)`
`void` `setShun(boolean flag)` Deprecated.
`void` `setTimeout(long timeout)`
`void` `startFailureDetection()`
`void` `stop()` This method is called on a `Channel.disconnect()`.
`void` `stopFailureDetection()`
`java.lang.Object` `up(Event evt)` An event was received from the layer below.

### Methods inherited from class org.jgroups.stack.Protocol

`destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, start, statsEnabled, upThreadEnabled`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### num_heartbeats_sent

    protected int num_heartbeats_sent

#### num_heartbeats_received

    protected int num_heartbeats_received

#### num_suspect_events

    protected int num_suspect_events

#### suspected_mbrs

    protected final java.util.Set<Address> suspected_mbrs

### Constructor Detail

#### FD_ALL

    public FD_ALL()

### Method Detail

#### getLocalAddress

    public java.lang.String getLocalAddress()

#### getMembers

    public java.lang.String getMembers()

#### getSuspectedMembers

    public java.lang.String getSuspectedMembers()

#### getHeartbeatsSent

    public int getHeartbeatsSent()

#### getHeartbeatsReceived

    public int getHeartbeatsReceived()

#### getSuspectEventsSent

    public int getSuspectEventsSent()

#### getTimeout

    public long getTimeout()

#### setTimeout

    public void setTimeout(long timeout)

#### getInterval

    public long getInterval()

#### setInterval

    public void setInterval(long interval)

#### isShun

    @Deprecated
    public static boolean isShun()

Deprecated.

#### setShun

    @Deprecated
    public void setShun(boolean flag)

Deprecated.

#### isRunning

    public boolean isRunning()

#### printSuspectHistory

    public java.lang.String printSuspectHistory()

#### printTimestamps

    public java.lang.String printTimestamps()

#### stopFailureDetection

    public void stopFailureDetection()

#### startFailureDetection

    public void startFailureDetection()

#### resetStats

    public void resetStats()

Overrides:
  `resetStats` in class `Protocol`

#### init

    public void init()
              throws java.lang.Exception

Description copied from class: `Protocol`
Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.

Overrides:
  `init` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

#### stop

    public void stop()

Description copied from class: `Protocol`
This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed

Overrides:
  `stop` in class `Protocol`

#### up

    public java.lang.Object up(Event evt)

Description copied from class: `Protocol`
An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.

Overrides:
  `up` in class `Protocol`

#### down

    public java.lang.Object down(Event evt)

Description copied from class: `Protocol`
An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.

Overrides:
  `down` in class `Protocol`